/***************************************************************************
                          switcher.cpp  -  description
                             -------------------
    begin                : Fri Mar 21 13:37:08 IST 2003
    copyright            : (C) 2003 by yuval
    email                : yyyme@walla.co.il
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

 /*the switcher xpm format icon:*/
 static const char *switchpix[]={
"16 16 5 1",
". c None",
"b c #0000ff",
"c c #c0c0ff",
"# c #ff0000",
"a c #ffffc0",
"................",
"................",
"................",
"....#...........",
"...#######......",
"..########a.....",
"...#######a.....",
"....#aaaaaa.....",
"..........b.....",
".....bbbbbbb....",
".....bbbbbbbb...",
".....bbbbbbbc...",
".....cccccbc....",
"..........cc....",
"................",
"................"};


#include <klocale.h>
#include <kiconloader.h>

#include <kpopupmenu.h>
#include <kmessagebox.h>
  
#include "gui.h"
#include "manager.h"
#include "errorcarrier.h"

MainGUI::MainGUI(QWidget *parent, const char *name) : KSystemTray(parent,name)
{
     tryagain:
  try
  {

  m_mng=new Manager;/*get a new Manager, to do the work*/
  }
  catch(const ErrorCarrier & err)
  {
    if(err.GetType()==ErrorCarrier::NO_MEM)
    {
     int answer=KMessageBox::questionYesNo(this,QString(err.getDescription())+"should I try to re-allocate (while you free some memory) ?\nPressing 'No' will close the program.","Not Enough memory");
     if (answer==KMessageBox::Yes)
     {
       goto tryagain;/*you did not see this goto! :)*/
     }
     else
     {
       /*die*/
       throw 0;/*if we throw a zero, it means that we want to exit the program, ok? good*/
     }
    }
    else
    {
    KMessageBox::sorry(this,i18n("This should not happen,there is an unkown error.\nProgram will close now,goodbye :) "),i18n("Unkown Error"));
      /*die*/
    throw 0;
    }

  }
  catch(...)
  {
     KMessageBox::sorry(this,"This really should not happen,there is an unkown error.\nProgram will close now.\nplease notify the developer","Unkown Error 2");
     throw 0;
  }
  if(m_mng==0)
      throw ErrorCarrier(ErrorCarrier::NO_MEM,i18n("Not enough memory to create a Manager for the program"));
  setAlignment(Qt::AlignHCenter | Qt::AlignVCenter);/*do something*/


  setPixmap(QPixmap(switchpix));//setting icon.
  
  m_popupmenu=contextMenu ();/*get a POP - UP menu, for right mouse clicking!!*/

  if(m_popupmenu==0)
   throw ErrorCarrier(ErrorCarrier::NO_MEM,i18n("Not enough memory to create a new pop menu."));

  /*add menu items, and save id's of items we want to check later*/
  m_menu_ids[AUTO_ID]= m_popupmenu->insertItem( i18n("Auto"),  this, SLOT(setAuto()));
  m_menu_ids[HEB_ID]= m_popupmenu->insertItem( i18n("Hebrew only"),  this, SLOT(setHeb()) );
  m_menu_ids[ENG_ID]= m_popupmenu->insertItem( i18n("English only")  ,  this, SLOT(setEng()) );
  m_popupmenu->insertSeparator();
  m_menu_ids[REV_ID]=  m_popupmenu->insertItem( i18n("Reverse Hebrew")  ,  this, SLOT(setRevHeb()) );
  m_menu_ids[UNICODE_ID]=  m_popupmenu->insertItem( i18n("8-bit Hebrew to Unicode")  ,  this, SLOT(setRev8Bit()));
  m_popupmenu->insertSeparator();
  m_menu_ids[PASTE_ID]= m_popupmenu->insertItem( i18n("Auto Paste Result"),this, SLOT( setPaste()  ));
  m_popupmenu->insertSeparator();
  m_popupmenu->insertItem( SmallIcon("configure") , i18n("&Configure Shotcut Keys"),this, SLOT(DisplayConfiguration()));
 // m_popupmenu->insertSeparator();/*already there..*/
 // m_popupmenu->insertItem(SmallIcon("exit"), i18n("&Quit"),this, SLOT(close()) );

  setAuto();/*set auto - so we have default values.*/
  /**/
  connect(m_mng,SIGNAL(updateGuiMenus()),SLOT(slotUpdateMenues()));
  m_mng->LoadConfigs();
}

MainGUI::~MainGUI()
{
delete m_mng;
m_mng=0;
}


void MainGUI::slotUpdateMenues()
{

  if (m_popupmenu->isItemChecked( m_menu_ids[PASTE_ID])!=m_mng->getDefaultPaste())
   setPaste();
   
  if((m_mng->getDefaultAction()==Manager::AUTO)&&   (m_popupmenu->isItemChecked(m_menu_ids[AUTO_ID])!=true))
   setAuto();
  else if((m_mng->getDefaultAction()==Manager::HEB)&&   (m_popupmenu->isItemChecked(m_menu_ids[HEB_ID])!=true))
   setHeb();
  else if((m_mng->getDefaultAction()==Manager::ENG)&&   (m_popupmenu->isItemChecked(m_menu_ids[ENG_ID])!=true))
   setEng();
  else if((m_mng->getDefaultAction()==Manager::REV)&&   (m_popupmenu->isItemChecked(m_menu_ids[REV_ID])!=true))
   setRevHeb();
  else if((m_mng->getDefaultAction()==Manager::UNICODE)&&   (m_popupmenu->isItemChecked(m_menu_ids[UNICODE_ID])!=true))
   setRev8Bit();

}

 void MainGUI::setPaste()
 {
  m_popupmenu->setItemChecked(m_menu_ids[PASTE_ID] ,!(m_popupmenu->isItemChecked( m_menu_ids[PASTE_ID] )));
  m_mng->setDefaultPaste(m_popupmenu->isItemChecked( m_menu_ids[PASTE_ID] ));
  

 }
 void MainGUI::setAuto()
  {
  m_popupmenu->setItemChecked(m_menu_ids[AUTO_ID] ,true);
  m_popupmenu->setItemChecked(m_menu_ids[ENG_ID] ,false);
  m_popupmenu->setItemChecked(m_menu_ids[HEB_ID] ,false);
  m_popupmenu->setItemChecked(m_menu_ids[REV_ID] ,false);
  m_popupmenu->setItemChecked(m_menu_ids[UNICODE_ID] ,false);
  m_mng->setDefaultAction(Manager::AUTO);
 }

 void MainGUI::setEng()
  {
  m_popupmenu->setItemChecked(m_menu_ids[AUTO_ID] ,false);
  m_popupmenu->setItemChecked(m_menu_ids[ENG_ID] ,true);
  m_popupmenu->setItemChecked(m_menu_ids[HEB_ID] ,false);
  m_popupmenu->setItemChecked(m_menu_ids[REV_ID] ,false);
  m_popupmenu->setItemChecked(m_menu_ids[UNICODE_ID] ,false);
  m_mng->setDefaultAction(Manager::ENG);
 }
 void MainGUI::setHeb()
  {
  m_popupmenu->setItemChecked(m_menu_ids[AUTO_ID] ,false);
  m_popupmenu->setItemChecked(m_menu_ids[ENG_ID] ,false);
  m_popupmenu->setItemChecked(m_menu_ids[HEB_ID] ,true);
  m_popupmenu->setItemChecked(m_menu_ids[REV_ID] ,false);
  m_popupmenu->setItemChecked(m_menu_ids[UNICODE_ID] ,false);
  m_mng->setDefaultAction(Manager::HEB);
 }
 void MainGUI::setRevHeb()
  {
  m_popupmenu->setItemChecked(m_menu_ids[AUTO_ID] ,false);
  m_popupmenu->setItemChecked(m_menu_ids[ENG_ID] ,false);
  m_popupmenu->setItemChecked(m_menu_ids[HEB_ID] ,false);
  m_popupmenu->setItemChecked(m_menu_ids[REV_ID] ,true);
  m_popupmenu->setItemChecked(m_menu_ids[UNICODE_ID] ,false);
  m_mng->setDefaultAction(Manager::REV);
 }
 void MainGUI::setRev8Bit()
  {
  m_popupmenu->setItemChecked(m_menu_ids[AUTO_ID] ,false);
  m_popupmenu->setItemChecked(m_menu_ids[ENG_ID] ,false);
  m_popupmenu->setItemChecked(m_menu_ids[HEB_ID] ,false);
  m_popupmenu->setItemChecked(m_menu_ids[REV_ID] ,false);
  m_popupmenu->setItemChecked(m_menu_ids[UNICODE_ID] ,true);
  m_mng->setDefaultAction(Manager::UNICODE);
 }

void MainGUI::DisplayConfiguration()
{
  m_mng->DisplayConfigurations();
}

void MainGUI::mousePressEvent(QMouseEvent *ev)
{
 if (ev->button() == LeftButton)
 {
  callManagerToDoSomeWork();

 }
 else /*let father handle it: */
   KSystemTray::mousePressEvent(ev);
}

void MainGUI::callManagerToDoSomeWork()
{
  if (m_popupmenu->isItemChecked( m_menu_ids[AUTO_ID] ) )
   m_mng->PerformAction(Manager::AUTO,m_popupmenu->isItemChecked( m_menu_ids[PASTE_ID] ));
  else if (m_popupmenu->isItemChecked( m_menu_ids[HEB_ID] ) )
   m_mng->PerformAction(Manager::HEB,m_popupmenu->isItemChecked( m_menu_ids[PASTE_ID] ));
  else if (m_popupmenu->isItemChecked( m_menu_ids[ENG_ID] ) )
   m_mng->PerformAction(Manager::ENG,m_popupmenu->isItemChecked( m_menu_ids[PASTE_ID] ));
  else if (m_popupmenu->isItemChecked( m_menu_ids[REV_ID] ) )
   m_mng->PerformAction(Manager::REV,m_popupmenu->isItemChecked( m_menu_ids[PASTE_ID] ));
  else if (m_popupmenu->isItemChecked( m_menu_ids[UNICODE_ID] ) )
   m_mng->PerformAction(Manager::UNICODE,m_popupmenu->isItemChecked( m_menu_ids[PASTE_ID] ));

}

  