/***************************************************************************
                          manager.cpp  -  description
                             -------------------
    begin                : ?' ??? 25 2003
    copyright            : (C) 2003 by yuval
    email                : yyyme@walla.co.il
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "manager.h"

#include "manager.h"
#include "xcom.h"
#include "clipcom.h"
#include "confman.h"
#include "switcher.h"
#include "errorcarrier.h"

#include <qstring.h>
#include <qrtlcodec.h>


Manager::Manager():  m_Action (AUTO),   m_bPaste(false)
{
 m_Clip = new ClipCom;
 if(m_Clip==0)
     throw ErrorCarrier(ErrorCarrier::NO_MEM,"Not enough memory to create Clipboard communication object.");
  m_X=new Xcom ;
   if(m_X==0)
     throw ErrorCarrier(ErrorCarrier::NO_MEM,"Not enough memory to create X communication object.");
  m_Conf=new ConfMan ;
   if(m_Conf==0)
     throw ErrorCarrier(ErrorCarrier::NO_MEM,"Not enough memory to create Configuration manager object.");
  m_sw=new Switcher;
   if(m_sw==0)
     throw ErrorCarrier(ErrorCarrier::NO_MEM,"Not enough memory to create Switcher object.");
  m_codec=new QHebrewCodec;
   if(m_codec==0)
     throw ErrorCarrier(ErrorCarrier::NO_MEM,"Not enough memory to create Hebrew Codec object.");
  
  m_swHeb8bitToUnicode=new Switcher;
   if(m_swHeb8bitToUnicode==0)
     throw ErrorCarrier(ErrorCarrier::NO_MEM,"Not enough memory to create a second Switcher object.");

     /*init the switchers : */

 m_sw->InsertWhatToSwitch( ('.'),QChar(TZADI_SOFIT) /*tzadi-sofit */);
 m_sw->InsertWhatToSwitch( ('/'),('.'));
 m_sw->InsertWhatToSwitch( ('q'), ('/'));
 m_sw->InsertWhatToSwitch( ('w'),('\''));
 m_sw->InsertWhatToSwitch( ('e'),(QChar(KOF)));
 m_sw->InsertWhatToSwitch( ('r'),(QChar(RESH)/*resh*/));
 m_sw->InsertWhatToSwitch( ('t'),(QChar(ALEF)/*alef*/));
 m_sw->InsertWhatToSwitch( ('y'), (QChar(TET)/*tet*/));
 m_sw->InsertWhatToSwitch( ('u'),(QChar(VAV)/*vav*/));
 m_sw->InsertWhatToSwitch( ('i'),(QChar(NUN_SOFIT)/*non-sofit*/));
 m_sw->InsertWhatToSwitch( ('o'),(QChar(MEM_SOFIT)/*mem sofit*/));
 m_sw->InsertWhatToSwitch( ('p'),(QChar(PE)/*pe*/));
 m_sw->InsertWhatToSwitch( ('a'),(QChar(SHIN)/*shin*/));
 m_sw->InsertWhatToSwitch( ('s'),(QChar(DALET)/*dalet*/));
 m_sw->InsertWhatToSwitch( ('d'),(QChar(GIMEL)/*gimel*/));
 m_sw->InsertWhatToSwitch( ('f'),(QChar(KAPH)/*kaph*/));
 m_sw->InsertWhatToSwitch( ('g'),(QChar(AIN)/*ain*/));
 m_sw->InsertWhatToSwitch( ('h'),(QChar(YOD)/*yod*/));
 m_sw->InsertWhatToSwitch( ('j'),(QChar(HET)/*het*/));
 m_sw->InsertWhatToSwitch( ('k'),(QChar(LAMED)/*lamed*/));
 m_sw->InsertWhatToSwitch( ('l'),(QChar(KAPH_SOFIT)/*kaph-sofit*/));
 m_sw->InsertWhatToSwitch( (';'),(QChar(PE_SOFIT)/*pe sofit*/));
 m_sw->InsertWhatToSwitch( ('z'),(QChar(ZAIN)/*zain*/));
 m_sw->InsertWhatToSwitch( ('x'),(QChar(SAMECH)/*samech*/));
 m_sw->InsertWhatToSwitch( ('c'),(QChar(BET)/*bet*/));
 m_sw->InsertWhatToSwitch( ('v'),(QChar(HE)/*he*/));
 m_sw->InsertWhatToSwitch( ('b'),(QChar(NUN)/*non*/));
 m_sw->InsertWhatToSwitch( ('n'),(QChar(MEM)/*mem*/));
 m_sw->InsertWhatToSwitch( ('m'),(QChar(TZADI)/*tzadi*/));
 m_sw->InsertWhatToSwitch( (','),(QChar(TAV)/*tav*/));
 
 
/*for 8bit -> unicode*/
 m_swHeb8bitToUnicode->InsertWhatToSwitch( (TZADI_SOFIT8),QChar(TZADI_SOFIT) /*tzadi-sofit */);
 m_swHeb8bitToUnicode->InsertWhatToSwitch( (KOF8),(QChar(KOF)));
 m_swHeb8bitToUnicode->InsertWhatToSwitch( (RESH8),(QChar(RESH)/*resh*/));
 m_swHeb8bitToUnicode->InsertWhatToSwitch( ALEF8/*\340*/,(QChar(ALEF)/*alef*/));
 m_swHeb8bitToUnicode->InsertWhatToSwitch(( TET8 ), (QChar(TET)/*tet*/));
 m_swHeb8bitToUnicode->InsertWhatToSwitch(( VAV8 ),(QChar(VAV)/*vav*/));
 m_swHeb8bitToUnicode->InsertWhatToSwitch(( NUN_SOFIT8 ),(QChar(NUN_SOFIT)/*non-sofit*/));
 m_swHeb8bitToUnicode->InsertWhatToSwitch(( MEM_SOFIT8 ),(QChar(MEM_SOFIT)/*mem sofit*/));
 m_swHeb8bitToUnicode->InsertWhatToSwitch(( PE8 ),(QChar(PE)/*pe*/));
 m_swHeb8bitToUnicode->InsertWhatToSwitch(( SHIN8 ),(QChar(SHIN)/*shin*/));
 m_swHeb8bitToUnicode->InsertWhatToSwitch(( DALET8 ),(QChar(DALET)/*dalet*/));
 m_swHeb8bitToUnicode->InsertWhatToSwitch(( GIMEL8 ),(QChar(GIMEL)/*gimel*/));
 m_swHeb8bitToUnicode->InsertWhatToSwitch(( KAPH8 ),(QChar(KAPH)/*kaph*/));
 m_swHeb8bitToUnicode->InsertWhatToSwitch(( AIN8 ),(QChar(AIN)/*ain*/));
 m_swHeb8bitToUnicode->InsertWhatToSwitch(( YOD8 ),(QChar(YOD)/*yod*/));
 m_swHeb8bitToUnicode->InsertWhatToSwitch(( HET8 ),(QChar(HET)/*het*/));
 m_swHeb8bitToUnicode->InsertWhatToSwitch(( LAMED8 ),(QChar(LAMED)/*lamed*/));
 m_swHeb8bitToUnicode->InsertWhatToSwitch(( KAPH_SOFIT8 ),(QChar(KAPH_SOFIT)/*kaph-sofit*/));
 m_swHeb8bitToUnicode->InsertWhatToSwitch(( PE_SOFIT8 ),(QChar(PE_SOFIT)/*pe sofit*/));
 m_swHeb8bitToUnicode->InsertWhatToSwitch(( ZAIN8 ),(QChar(ZAIN)/*zain*/));
 m_swHeb8bitToUnicode->InsertWhatToSwitch(( SAMECH8 ),(QChar(SAMECH)/*samech*/));
 m_swHeb8bitToUnicode->InsertWhatToSwitch(( BET8 ),(QChar(BET)/*bet*/));
 m_swHeb8bitToUnicode->InsertWhatToSwitch(( HE8 ),(QChar(HE)/*he*/));
 m_swHeb8bitToUnicode->InsertWhatToSwitch(( NUN8 ),(QChar(NUN)/*non*/));
 m_swHeb8bitToUnicode->InsertWhatToSwitch(( MEM8 ),(QChar(MEM)/*mem*/));
 m_swHeb8bitToUnicode->InsertWhatToSwitch( ( TZADI8 ),(QChar(TZADI)/*tzadi*/));
 m_swHeb8bitToUnicode->InsertWhatToSwitch( ( TAV8 ),(QChar(TAV)/*tav*/));
 /**/

}

void Manager::LoadConfigs()
 {
  if(m_Conf==0)return; /*Load Configs:*/

 m_Conf->LoadConfigs(this);

 emit updateGuiMenus();/*update gui menues..*/

 }

 
Manager::~Manager(){
  m_Conf->SaveConfigs(this);/*save configs.*/

  delete m_Clip;
  delete m_X;
  delete m_Conf;
  m_Clip=0;
  m_X=0;
  m_Conf=0;
}

void Manager::DisplayConfigurations()
{
  m_Conf->DisplayConf();
}


void Manager::PerformAction(SwitchTypes action, bool Paste)
{

    
    QString s=m_Clip->GetClipBoardString()/*get input string*/,result/*outputstring*/;

  switch (action)/*see which action to do and do it*/
  {
    case AUTO:   
    result= m_sw->BothSwitch(s);
    break;
    case ENG:
    result= m_sw->Switch(s);
    break;

    case HEB:
    result= m_sw->RevSwitch(s);
    break;

    case UNICODE:
    result= m_swHeb8bitToUnicode->Switch(s);
    break;

    case REV:
     int number;
     QCString string= m_codec->fromUnicode(s,number);
     result=m_swHeb8bitToUnicode->Switch(string);
    break;
  }
  /*from some reson , if u first sendkeys to x and then try copy it gets messy*/
  m_Clip->SetClipBoardString(result);/*put the result in the clipboard*/

  
      
    if(Paste)/*paste result to focues window*/
    {
      m_X->SendDelete();
      m_X->SendPaste();//String(s);
    }
}
