/***************************************************************************
                          manager.h  -  description
                             -------------------
    begin                : ?' ??? 25 2003
    copyright            : (C) 2003 by yuval
    email                : yyyme@walla.co.il
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef MANAGER_H
#define MANAGER_H

#include <qobject.h>

/**
  *@author yuval
  */

  class  ClipCom;
class  Xcom;
class  ConfMan;
class Switcher;
class QHebrewCodec;


class Manager : public QObject  {
  Q_OBJECT
         /*the hebrew aleph bet unicode represtation*/
        enum alpehBetUNICOED{ALEF=0x05d0,BET,GIMEL,DALET,HE,VAV,ZAIN,HET,TET ,
        YOD,KAPH_SOFIT,KAPH,LAMED,MEM_SOFIT,MEM,NUN_SOFIT,NUN,SAMECH,AIN,PE_SOFIT,PE,
         TZADI_SOFIT,TZADI,KOF,RESH,SHIN,TAV};
        enum alpehBet8BIT{ALEF8=224,BET8,GIMEL8,DALET8,HE8,VAV8,ZAIN8,HET8,TET8 ,
        YOD8,KAPH_SOFIT8,KAPH8,LAMED8,MEM_SOFIT8,MEM8,NUN_SOFIT8,NUN8,SAMECH8,AIN8,PE_SOFIT8,PE8,
         TZADI_SOFIT8,TZADI8,KOF8,RESH8,SHIN8,TAV8};

public:
/*what we can do*/
  enum SwitchTypes{AUTO,HEB,ENG,REV,UNICODE};
  
private:
  SwitchTypes m_Action;/*current action*/
  bool m_bPaste;/*should i paste the result ?*/
  QHebrewCodec *m_codec;/*codec to make visual hebrew to logical*/
  ClipCom *m_Clip;/*clip baord communication object*/
  Xcom *m_X; /*X communication objecy*/
  ConfMan *m_Conf;/*configutayion manager*/
  Switcher * m_sw,*m_swHeb8bitToUnicode;/*switcher objects*/
  public: 
  void DisplayConfigurations();/*display conf*/
  void setDefaultAction(SwitchTypes action){m_Action=action;}//need to fund a way to update gui, a signal might be of use.
  void setDefaultPaste(bool Paste){m_bPaste=Paste;}
  SwitchTypes getDefaultAction()const {return m_Action;}
  bool getDefaultPaste()const{return m_bPaste;}
	Manager();
	~Manager();
  void LoadConfigs(); /*load saved configurations*/
  void emitUpdateGuiMenues(){emit updateGuiMenus();}
  public slots:
  void PerformDefaultAction(){PerformAction(m_Action,m_bPaste);}
  void PerformActionWithDefaultPaste(SwitchTypes action){PerformAction(action,m_bPaste);}
  
  void PerformAction(SwitchTypes action, bool Paste=false);/*do action*/
  signals:
  void updateGuiMenus();/*tell gui to update its menus.*/
};

#endif
