/***************************************************************************
                          switcher.cpp  -  description
                             -------------------
    begin                : '   1 22:12:17 UTC 2002
    copyright            : (C) 2002 by Yuval
    email                : yuval@Yuval
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "switcher.h"


#include <qregexp.h>
Switcher::Switcher()
{

}

Switcher::~Switcher()
{
}

/*
  switcher
  the string str
  and returns the switched string.
  switching is done like so:
  if a char in the string is found in the switch_what vector,
  it is switcher to the char on the same index in switch with vector.
*/
/*due to the nature of QString,
 returning a QString is almost like returning a pointer to it.*/
QString Switcher::SwitchWith(const QString &str,const vect &switch_what,const vect & switch_with)
{

 if(str.isNull()) /*if null given*/
  return QString();/*return null string*/

 QString ret(str);/*else, make a copy*/
 int tempIndex; /*index*/
 QChar tmp;/*temp char of compersons*/
 for(unsigned i=0;i<ret.length();++i)
 {
   tmp=ret[i].lower();
   tempIndex=switch_what.findElement(tmp);/*find char*/
   if(tempIndex<0)
     continue;
  ret[i]= switch_with.getElement(tempIndex);/*char found ,so switch*/
 }

 return ret;
}
QString Switcher::Switch(const QString &str)
{
 return SwitchWith(str,v_what_to_switch,v_switch_with_me);
}
QString Switcher::RevSwitch(const QString &str)
{
 return SwitchWith(str,v_switch_with_me,v_what_to_switch);
}

QString Switcher::BothSwitch(const QString &str)
{
 return SwitchWithBoth(str,v_what_to_switch,v_switch_with_me);
}

/*takes a string, and switches letters from bot vectors in this fation:
for every string char:
*if a char is found in one vector, switch it with the char with the same index on the other vector
*if not found , search it in the second vector, and switch simillarly with the co-responging char on the first vector

*/
QString Switcher::SwitchWithBoth(const QString &str,const vect &switch_what,const vect & switch_with)
{
 if(str.isNull())
  return QString();/*null string*/
 QString ret(str);
 int tempIndex;
 QChar tmp;
 for(unsigned i=0;i<ret.length();++i)
 {
   tmp=ret[i].lower();
   tempIndex=switch_what.findElement(tmp);
   if(tempIndex>=0)
     ret[i]= switch_with.getElement(tempIndex);
   else
    {
      tempIndex=switch_with.findElement(tmp);
      if(tempIndex<0)
         continue;
       ret[i]= switch_what.getElement(tempIndex);
    }

 }

 return ret;
}
/*insert a pair - one to be switch, and one we switch with*/
void Switcher::InsertWhatToSwitch(QChar c_what_to_switch,QChar c_switch_with_me)
{
 v_what_to_switch.insertElement(c_what_to_switch );
 v_switch_with_me.insertElement(c_switch_with_me);
}
